<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ page language="java" contentType="text/html; charset=UTF-8"  pageEncoding="UTF-8"%>
<%@ taglib uri="http://www.springframework.org/tags/form" prefix="form"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>

<%@ page import="java.util.Locale"%>
<%@ page import="com.emptoris.viewer.util.CSRFHelper"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@ page import="com.emptoris.viewer.dashboards.common.util.DashboardConstants"%>
<%@ page import="com.zeborg.expensemap.view.HelpUtil" %>
<%@ page import="com.zeborg.expensemap.view.CubeUtil"%>
<%@ page import="com.zeborg.expensemap.view2.ZSession, com.zeborg.expensemap.view.ZSessionUtil"%>

<%
		ZSession zs = ZSessionUtil.getFromSession(pageContext);
		Locale locale = zs.getUser().getLocale();		
		String cubeName = zs.getDataSet().getDisplayName();	
		String helpURL = HelpUtil.getHelpUtil().getHelpURLString(DashboardConstants.DASHBOARD_LIST_PAGE_HELP_URL, locale);
		pageContext.setAttribute("returnToURL","../showDashboardPage.xhtm", PageContext.SESSION_SCOPE);
%>
<c:set var="userDatePattern" value="<%=zs.getUser().getDateFormat()%>" />

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
		<title><%=ExpenseMapAppProperties.getBrowserTitleSpend()%> - <fmt:message key="ui.dashboard.list.title"/></title>
			<jsp:include page="/jsp/includes/commonHeaderIncludes.jsp"/>				
			<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dijit/themes/dijit.css"/>
			<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dijit/themes/dijit_rtl.css"/>
			<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dijit/themes/claro/claro.css"/>
			<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dijit/themes/claro/claro_rtl.css"/>
			<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dojox/grid/resources/Grid.css"/>
			<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dojox/grid/resources/Grid_rtl.css"/>
			<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dojox/grid/resources/claroGrid.css"/>
			<link rel="stylesheet" href="/expensemap/css/spendGridPageStyle.css"/>
			
			<!--Locate the base path for DOJO Component -->

			<script type="text/javascript">
				dojoConfig = {
					baseUrl : "/expensemap/jsp/javascript/idx/dojo_1.7.2/dojo/"						
				};
			</script>
		
			<!-- Locate the dojo.js file. -->

			<script type="text/javascript" src="/expensemap/jsp/javascript/idx/dojo_1.7.2/dojo/dojo.js" data-dojo-config="parseOnLoad: true" ></script>
			
			<!-- Include DOJO component -->

			<script type="text/javascript">				
				dojo.require("dojo/domReady");
				dojo.require("dojo/store/Memory");
				dojo.require("dojo/data/ObjectStore");
				dojo.require("dojox/grid/DataGrid");
				dojo.require("dojo/_base/xhr");
				dojo.require("dijit/layout/BorderContainer");
				dojo.require("dijit/form/Button");
				dojo.require("dijit/form/Select");
				dojo.require("dijit/TitlePane");
				dojo.require("dijit/form/TextBox");
				dojo.require("dijit/form/CheckBox");
				dojo.require('dijit/form/NumberTextBox');
				dojo.require("dijit/form/DateTextBox");
				dojo.require("dijit/form/ValidationTextBox");


				// Global variables 
				var dashboard_Grid_Layout, dashboard_Grid_Store, dashboard_Grid_Obj, dataStore, categoryLabelValue;
				var isRootUser=true;

				 
				dojo.ready(function(){

					// Layout for grid. It will define the column definition for each column. Exmple: CSS,Function to render the column-'formatter',width,id etc...
					dashboard_Grid_Layout = [
												{													
													name: "<input id='selectAllRows' name='selectAllRows' type='checkbox' onClick='selectAll(this);' />",
													fields :['id','deleteEnabled'],
													formatter:addCheckBox,
													width:"30px"
												},{
													id: 'name',
													name: '<fmt:message key="ui.label.Name" />',
													fields: ['name'],
													formatter:createLink,
													headerStyles:"cursor:pointer",
													editable:true,
													width:"23%"
												},{
													id: 'sharedBy',
													fields:['sharedBy','owner'],													
													formatter:renderSharedBy,
													name: '<fmt:message key="ui.label.Shared.By"/>',
													headerStyles:"cursor:pointer",
													width:"13%"
												},{
													id: 'completeDescription',
													field:'completeDescription',
													formatter:renderDescription,
													name: '<fmt:message key="ui.label.Description"/>',
													headerStyles:"cursor:pointer",
													editable:true,
													width:"40%"
												},{
													id: 'dateCreated',
													fields:['dateCreatedStr'],
													formatter:renderDateCreated,
													name: '<fmt:message key="ui.label.Date.Created"/>',												
													headerStyles:"cursor:pointer",
													width:"10%"
												},{
													id: 'lastUpdated',
													fields:['dateUpdatedStr'],
													formatter:renderDateUpdated,
													name: '<fmt:message key="ui.label.Date.Last.Updated"/>',												
													headerStyles:"cursor:pointer",
													width:"10%"
												},{
													id: 'Share',
													fields:['id','shareEnabled'],													
													name: '<fmt:message key="ui.label.Share"/>',
													formatter:renderShareIcon,												
													width:"5%"
												}
											];
							
					require(["dojox/grid/DataGrid", "dojo/store/Memory", "dojo/data/ObjectStore", "dojo/_base/xhr", "dojo/domReady", "dijit/form/Select"],
						function(DataGrid, Memory, ObjectStore, xhr){
								xhr.post({
									url: "/expensemap/fetchDashboardList.jxhtm",
									handleAs: "json",
									content:{theAction: "showAll"}
								}).then(function(responseData){
									dashboard_Grid_Store = new dojo.store.Memory({ data: responseData.dashboardList });
									categoryLabelValue = new dijit.form.Select({
																					id:"category",
																					name: "category",
																					store: new ObjectStore({ objectStore: new Memory({ data: responseData.categorylabelvalue })}),
																					maxHeight: -1
																				}
																					,"category_div");
									categoryLabelValue.startup();
									showTopReortDiv(responseData);
									enableDisableButton_OnGridLoad();	
									configurePaginationComponent(responseData.dashboardListForm.pagination);												
									dataStore = new ObjectStore({ objectStore: dashboard_Grid_Store });
     									dashboard_Grid_Obj = new DataGrid({
																		id:'dashboard_Grid',
																		autoHeight:true,
																		store: dataStore,																			
																		canSort : canSort,
																		canEdit : isEditable,
																		rowSelector:'0px',
																		selectionMode:"single",
																		onCellMouseOver: showImage,
																		onCellMouseOut: hideImage,
																		onApplyCellEdit : renameDashboard,
																		escapeHTMLInData:false,
																		structure : dashboard_Grid_Layout			
																	},																		
																	"Grid_Div"
															);// End of DataGrid.										
									dashboard_Grid_Obj.startup();
									dojo.connect(dashboard_Grid_Obj, 'onStartEdit', function(inCell, inRowIndex) {
										oldNameValue = eval(dashboard_Grid_Obj.getItem(inRowIndex)).name; 
										oldDescValue = eval(dashboard_Grid_Obj.getItem(inRowIndex)).completeDescription;
									});	
								});
					});

					require(["dojo/on", "dojo/topic", "dojo/dom-construct"],
						function(on, topic, domConstruct) {
					});// End of Event handler require.
					
				});// End of dojo.ready

	/* All button event handler  -- START */
function onReset()			
{
				
	resetSearchOptions();								
}
function onSearch()
{
	dojo.byId("theAction").value = "showAll";								
	showAllDashboard();

}
function onShowAll()
{	
								dojo.byId("theAction").value = "showAll";
								resetSearchOptions();
								showAllDashboard();
}
function onDelete()
{
		
				if(!dijit.byId("delete").get('disabled')){
					deleteDashboards();									
				}

}
function onCreate()
{

		createNewDashBoard();
}
function onTopReport()
{
										
		if(!dijit.byId("topReport").get('disabled')){											
		dojo.byId("theAction").value="getCurrent";
			saveAsTopReport();
		}

}
function onApplyPageSize()
{

								dojo.byId("pageSize").value = dojo.byId("userInput_pageSize").value;									
								dojo.byId("theAction").value="getCurrent";										
								showAllDashboard();

}
/* All button event handler  -- END */

				function deleteDashboards(){
					dojo.byId("theAction").value="getCurrent";
					var frm = dojo.byId("dashboardListForm");
					var dashboardIdsToDelete = [];
					var isSelected = checkAtLeastOneSelected();	
									
					if(!isSelected){
						alert("<fmt:message key='ui.dashboard.delete.no.dashboard.selected'/>");
						return false;
					}

					if(frm.dashboardIds.length){
						var noOfRows = frm.dashboardIds.length;
						for (i = 0; i < noOfRows; i++) {											
							if (frm.dashboardIds[i].checked == true ) {															
								if(frm.dashboardIds[i].value.substring(frm.dashboardIds[i].value.indexOf(":")+1,frm.dashboardIds[i].value.length)=='false'){
									alert("<fmt:message key='ui.dashboard.shared.with.role.cannot.deleted' />");
									dashboardIdsToDelete = [];
									return false;
								}else{
									dashboardIdsToDelete.push(frm.dashboardIds[i].value.substring(0,frm.dashboardIds[i].value.indexOf(":")));
								}
							}
						}
					}else{
						if (frm.dashboardIds.checked == true ) {															
								if(frm.dashboardIds.value.substring(frm.dashboardIds.value.indexOf(":")+1,frm.dashboardIds.value.length)=='false'){
									alert("<fmt:message key='ui.dashboard.shared.with.role.cannot.deleted'/>");
									dashboardIdsToDelete = [];
									return false;
								}else{
									dashboardIdsToDelete.push(frm.dashboardIds.value.substring(0,frm.dashboardIds.value.indexOf(":")));
								}
							}
					}
									
					if (confirm('<fmt:message key="ui.delete.alertmsg"/>')) {
						frm.action="/expensemap/deleteDashBoard.jxhtm";										
						var xhrArgs = {
							form: frm,
							handleAs: "json",
							content:{dashboardIds:dashboardIdsToDelete},
							load: function(data){
								refreshGridStore(data);
							}// end of load.										
						}// End of xhrArgs.
						dojo.xhrPost(xhrArgs);
					}
				}//End of Dashboard function.

				function exportToPDF(){
					if(checkAtLeastOneSelected()){
						var ht = 500;
						var wt = 750;
						var left = (screen.width/2)-(wt/2);
						var top = (screen.height/2)-(ht/2);	
						var exportList ="";
						var theForm = document.getElementById("dashboardListForm");
						if(theForm.dashboardIds.length){
							//if multiple selected
							for( var i=0; i< theForm.dashboardIds.length; i++ ) {
								if(theForm.dashboardIds[i].checked == true){
									if(exportList!="") 
										exportList = exportList + ",";
									
									exportList = exportList + theForm.dashboardIds[i].value.substring(0,theForm.dashboardIds[i].value.indexOf(":"));
								}
							}
						}else{
							exportList = theForm.dashboardIds.value.substring(0,theForm.dashboardIds.value.indexOf(":"));
						}						
						window.open("/expensemap/dashboards/getPDFExportDialog.do?exportType=booklet&exportList="+exportList,"_blank","resizable=yes,scrollbars=yes,height="+ht+",width="+wt+",menubar=no,	toolbar=no,left="+left+",top="+top);
					}else{
						alert("<fmt:message key='ui.dashboard.export.to.pdf.no.dashboard.selected' />");
						return false;
					}	

				}

				// Check inline edit is possible with this cell
				function isEditable (inCell, inRowIndex){
				   var grid = dijit.byId("dashboard_Grid");
				   var isOwner = eval(grid.getItem(inRowIndex)).owner;
				   var shareEnabled = eval(grid.getItem(inRowIndex)).shareEnabled;
				   if (!isOwner || !shareEnabled ){
						return false;
				   }
				   
				   //If there are no creational permissions for dashboard, then data_grid will
				   //not be editable.
				   return eval(document.getElementById("createPermission").value);
			    }

				// displays edit icon on mouser over
				// On Mouse over verify that dashboard has creational permissions
				function showImage(e){
					var imageDiv;
					if(e.cell.id === 'name'){
						imageDiv = dojo.byId("imageDivName"+e.rowIndex);
					}else if( e.cell.id === 'completeDescription'){
						imageDiv = dojo.byId("imageDivDescription"+e.rowIndex);
					} 
					showImageIfCreationalPermission(imageDiv);
				}
				
				function showImageIfCreationalPermission(imageDiv){
					var createPermission = eval(document.getElementById("createPermission").value);
					if(imageDiv){
						if(createPermission){
							imageDiv.style.visibility = '';
						}else{
							imageDiv.style.visibility = 'hidden';
						}
					}
				}
				
				// hides edit icon on mouser out
				function hideImage(e){
					if(e.cell.id == 'name' || e.cell.id == 'completeDescription'){
					  var imgDivName = dojo.byId("imageDivName"+e.rowIndex);
					  var imgDivDesc = dojo.byId("imageDivDescription"+e.rowIndex);
					 
					  if(imgDivName){
						  imgDivName.style.visibility = 'hidden';
						} 
					  if(imgDivDesc){
						  imgDivDesc.style.visibility = 'hidden';
						}
					}
				}				

				// Function for inline edit.
			    function renameDashboard(inValue, inRowIndex, inFieldIndex){
					  var grid = dijit.byId("dashboard_Grid");
					  var dashboardId = eval(grid.getItem(inRowIndex)).id;
					  var dashboardName = eval(grid.getItem(inRowIndex)).name;					  
					  var desc = eval(grid.getItem(inRowIndex)).completeDescription;
					  var isOwner = eval(grid.getItem(inRowIndex)).owner;
					  var shareEnabled = eval(grid.getItem(inRowIndex)).shareEnabled;
					  var errorMessage = document.getElementById("errorMsg_grid");
					  var isDashboardNameEdit = false;
					  
					  if(inFieldIndex=="completeDescription"){
						  if (inValue === oldDescValue) {
								errorMessage.style.display = "none";
								errorMessage.innerHTML = '' ;
								return false;
						}
						  desc = dojo.trim(inValue); 
					  }
					  
					  // XXX: We get undefined for name column. Could be a bug with Dojo Datagrid.
					  if (inFieldIndex == undefined) {
						  if (inValue === oldNameValue) {
								errorMessage.style.display = "none";
								errorMessage.innerHTML = '' ;
								return;
						  }
						  dashboardName = dojo.trim(inValue); 
						  isDashboardNameEdit = true;
					  }
					  if(dashboardName == ""){
						  errorMessage.style.display = "block";
						  var store = grid.store;
						  // XXX: We get undefined for name column. Could be a bug with Dojo Datagrid.
						  if (inFieldIndex == undefined) {
							errorMessage.innerHTML = '<fmt:message key="ui.message.Please.fill.in.the.following.field.s.."/> <fmt:message key="ui.label.Name" />' ;
							store.setValue(grid.getItem(inRowIndex), inFieldIndex, oldNameValue);
						  }
						  grid.update();
						  return false;
					  }else {
						  errorMessage.style.display = "none";
						  errorMessage.innerHTML = '' ;
					  }
					  
					  
					  if(dashboardName.length > 255){
						  errorMessage.style.display = "block";
						  errorMessage.innerHTML = '<fmt:message key="ui.message.name.is.too.long.please.enter.maximum.255.characters.in.name.field"/>' ;
						  var store = grid.store;
						  store.setValue(grid.getItem(inRowIndex), inFieldIndex, oldNameValue);
						  grid.update();
						  return false;
					  }else {
						  errorMessage.style.display = "none";
						  errorMessage.innerHTML = '' ;
						}
					  
					
					  if(!isEmpty(desc) &&  desc.length >255){
						  errorMessage.style.display = "block";
						  errorMessage.innerHTML = '<fmt:message key="ui.message.description.is.too.long.please.enter.maximum.255.characters.in.description.field"/>' ;
						  var store = grid.store;
						  store.setValue(grid.getItem(inRowIndex), inFieldIndex, oldDescValue);
						  grid.update();
						  return false;
					  }else {
						  errorMessage.style.display = "none";
						  errorMessage.innerHTML = '' ;
					  }											 					
						
						
						var frm = dojo.byId("dashboardListForm");
						frm.action="/expensemap/inlineEditDashboard.jxhtm";		
						var xhrArgs = {
							form: frm,
							handleAs: "json",
							content : {description:desc,id:dashboardId,name:dashboardName,"nameEdit":isDashboardNameEdit,theAction:"getCurrent"},
							load: function(data){
								refreshGridStore(data);
							}// end of load.										
						}// End of xhrArgs.
					dojo.xhrPost(xhrArgs);
				}
						

				// Will refresh dashboard grid and other component as per action (delete/save as top report/search/showAll)
				function refreshGridStore(responseData){
					
					if(!validateUserSession(responseData)) return false; // function validateUserSession() defined with topMenu.jsp	
					displayErrorIfAny(responseData);					
					showTopReortDiv(responseData);
					enableDisableButton_OnGridLoad();
					configurePaginationComponent(responseData.dashboardListForm.pagination);	
					var newStore = new dojo.store.Memory({ data: responseData.dashboardList });						
					var newDataStore = new dojo.data.ObjectStore({ objectStore: newStore });		
					dashboard_Grid_Obj.setStore(newDataStore);			
				}

				// Handle server reported errors 
				function displayErrorIfAny(responseData){
					var gridMsgDiv = document.getElementById("errorMsg_grid");
					var searchMsgDiv = document.getElementById("errorMsg_search");
					gridMsgDiv.style.display = "none";
					gridMsgDiv.innerHTML =  "";
					searchMsgDiv.style.display = "none";						
					searchMsgDiv.innerHTML = "";						
					if(responseData.errorMsg_grid != 'undefined' && responseData.errorMsg_grid != null ){
						gridMsgDiv.style.display = "block";
						gridMsgDiv.innerHTML =  "<b>"+responseData.errorMsg_grid+"</b>";
					}
					if(responseData.errorMsg_search != 'undefined' && responseData.errorMsg_search != null){
						searchMsgDiv.style.display = "block";
						searchMsgDiv.innerHTML = "<b>" + responseData.errorMsg_search + "</b>";
					}
				}
				
				// Will fetch all dashboard as per search condition.
				function showAllDashboard(){
					var frm = dojo.byId("dashboardListForm");
					frm.action="/expensemap/fetchDashboardList.jxhtm";	
					var xhrArgs = {
									form: frm,
									handleAs: "json",
									load: function(data){
										refreshGridStore(data);
									}// end of load.										
								  }// End of xhrArgs.
					dojo.xhrPost(xhrArgs);
				}
				// delete selected Dashboard
				function deleteDashboard(){

				}
				// Create public/private top report
				function saveAsTopReport(){
					var frm = document.getElementById("dashboardListForm");					
					var reportCategory=frm.category.value;					
					var privateReport=frm.privateReport.checked;
					var confirmMsg = '';
					if(privateReport) {
						confirmMsg = "<fmt:message key='ui.save.topreport.private.continue.alertmsg'/>";
					} else {
						confirmMsg = "<fmt:message key='ui.save.topreport.alertmsg'/>";
					}
					if (confirm(confirmMsg)) {
						frm.action = "/expensemap/saveDashboardAsTopReport.jxhtm";
						var xhrArgs = { 
											form:frm,
											handleAs: "json",												
											content: {category:reportCategory,privateReport: privateReport},
											load: function(data){
													refreshGridStore(data);
											}};										  
						dojo.xhrPost(xhrArgs);
					}else{
						return false;
					}
				}
				// Function will render dashboard
				function renderDashboard(id){
					var frm = document.getElementById("dashboardListForm");
					frm.action = "/expensemap/dashboards/renderDashboard.do?dashBoardId="+id;
					frm.method = "post";
					frm.submit();

				}

				function resetSearchOptions(){
					dijit.byId("search_dashboardName").set('value','');
					dijit.byId("search_FromDate").set('value',' ');
					dijit.byId("search_ToDate").set('value',' ');
					dijit.byId("search_createdBy").set('value','');					
					HideSearchErrDiv();
				}

				function HideSearchErrDiv(){
					var searchErrDiv = document.getElementById("errorMsg_search");
					if(searchErrDiv.style.display=='block'){
						searchErrDiv.innerHTML="";
						searchErrDiv.style.display='none';
					}
				}


				function canSort(col){				
					var returnVal = true;				
					//positive for an ascending sort and negative for a descending sort
					var sortingOrder = "desc";
					if(col > 0){
						sortingOrder="asc";
					}

					document.getElementById("listSortOrder").value = sortingOrder;

					var sortingColName;

					switch(col){												
						case 2:	case -2:
							sortingColName = "name";
							break;
						case 5: case -5:
							sortingColName = "dateCreated";
							break;					
						case 6:	case -6:
							sortingColName = "dateUpdated";
							break;	
						case 1: case -1:
						case 3:	case -3:
						case 4:	case -4:
						case 7: case -7:						
							returnVal = false;
							break;					
										
					}				
					document.getElementById("listSortColumnName").value = sortingColName;
					document.getElementById("theAction").value="getCurrent";
					if(returnVal){ showAllDashboard();}

					return returnVal;
				}

				// Function will add check box per row.
				// If dashboard is delete enabled then checkBox status will be enabled otherwise will be disabled.
				// fields [id , deleteEnabled]

				function addCheckBox(fields){					
					return '<input type="checkbox" name="dashboardIds"  value="'+ fields[0] +':' + fields[1] + '" onclick="updateSelectAll(this);"/>';
				}

				// This will render Dashboard name.
				// fields: ['name']
				function createLink(fields, inRowIndex){
					var grid = dijit.byId("dashboard_Grid");
					var id = eval(grid.getItem(inRowIndex)).id;
					var hasDroppedMembers = eval(grid.getItem(inRowIndex)).hasDroppedMembers;					
					var isTopReport = eval(grid.getItem(inRowIndex)).topReport;
					var isPrivateTopReport = eval(grid.getItem(inRowIndex)).privateTopReport;
					var linkString = '';
				    var shareEnabled = eval(grid.getItem(inRowIndex)).shareEnabled;
					if(hasDroppedMembers){						
						linkString += "<img src='/expensemap/jsp/images/report/reports_icon_data_refreshed.gif' title='<fmt:message key='crosstab.refreshed.filters'/>' border='0'>";		
					}
					if(isTopReport){
						linkString += "<img src='/expensemap/jsp/images/report/reports_icon.gif' border='0' title='<fmt:message key='ui.topn.Top.Report'/>'>";						
					}
					if(isPrivateTopReport){
						linkString += "<img src='/expensemap/jsp/images/report/private_reports_icon.jpg' border='0' title='<fmt:message key='ui.topn.Private.Top.Report'/>'>";						
					}

					linkString += "<a href=# onclick=renderDashboard(\'" + id + "\')>" + fields[0] + "</a>";
					if(shareEnabled){
						linkString += "<span style='visibility:hidden;margin-left:10px' id='imageDivName" + inRowIndex+"' ><img  src='/expensemap/jsp/images/edit.gif' border='0' /></span>";
					}
					return linkString;
				}

				// Function will render ownership field.
				// field:'owner'
				function renderOwnership(field){
					
					if(isEmpty(field)) return "&nbsp;";

					if(field) return "<img src='/expensemap/jsp/images/nonshared.gif' />";
					return "<img src='/expensemap/jsp/images/shared.gif' />";
				}

				// Function will render Shared By Column.
				// fields:['sharedBy','owner'],
				function renderSharedBy(fields){					
					if(!fields[1])
						return fields[0];
					return "&nbsp;";
				}

				//Function will render description of Dashboard objects
				////field:'completeDescription'
				function renderDescription(field, inRowIndex){
					var grid = dijit.byId("dashboard_Grid");
				    var shareEnabled = eval(grid.getItem(inRowIndex)).shareEnabled;
					var editLink = "";
					if(shareEnabled){

						editLink = '<span style="visibility:hidden;margin-left:10px" id="imageDivDescription'+inRowIndex+'" >' +
														 '<img  src="/expensemap/jsp/images/edit.gif" border="0"/></span>';
					}
					if(isEmpty(field)) return "&nbsp;" + editLink;
					return field + editLink;				}
				
				//Function will render creation date of Dashboard objects
				//field:dateCreatedStr
				function renderDateCreated(fields){
					if(isEmpty(fields[0])) return "&nbsp;";
					
					return fields[0];					
				}

				//Function will render last updated date of Dashboard objects
				//field:dateUpdatedStr
				function renderDateUpdated(fields){
					if(isEmpty(fields[0])) return "&nbsp;";					
					
					return fields[0];					
				}

				//Function will render share Icon. If dashboard is shared Enabled then it will show the Share object icon.
				//fields:['id','shareEnabled'],
				function renderShareIcon(fields){
					if(fields[1])
						return '<a href=# onclick=shareView(\'' + fields[0] + '\');><img src=/expensemap/jsp/images/share_icon.gif border=0/></a>';					
					return "&nbsp;";
				}

				// Will open share dashboard pop up.
				function shareView(dashboardId){
					var ht = 475;
					var wt = 935;
					var left = (screen.width/2)-(wt/2);
					var top = (screen.height/2)-(ht/2);	
					open('/expensemap/shareObject.shtm?viewType=dashboard&id=' + dashboardId, '_blank', "resizable=yes,scrollbars=yes,height="+ht+",width="+wt+",menubar=no,toolbar=no,left="+left+",top="+top);
				}
				
				// Function will check whether field is Empty or not.
				function isEmpty(field){
					if( field != null && field != "" )	return false;

					return true;
				}

				// If all dashboard check box is selected then will update "selectAll" check box.
				function updateSelectAll(checkboxSelected) {			
					var theForm = document.getElementById("dashboardListForm");
					var selectAllControl = document.getElementById("selectAllRows");
					var allSelected = true;			
					
					if (!theForm.dashboardIds.length ) {
						allSelected = checkboxSelected.checked;
					} else {
						for( var i=0; i< theForm.dashboardIds.length; i++ ) {
							if ( theForm.dashboardIds[i].checked == false ) {
								allSelected = false;
								break;
							}
						}
					}

					selectAllControl.checked = allSelected;
					if (checkAtLeastOneSelected()) {
						dijit.byId("delete").set("disabled",false);
						enableDisableComponents(false);					
					}else{
						dijit.byId("delete").set("disabled",true);
						enableDisableComponents(true);					
					}				
				}

				// If "selectAll" check box is selected then will updated all dashboard check box
				function selectAll(selectAllControl) {
					var theForm =  document.getElementById("dashboardListForm");
					if ( theForm.dashboardIds == null ) {
						document.getElementById("selectAllRows").checked=false;
						document.getElementById("selectAllRows").disabled=true;
						return false;	
					} 

					if ( theForm.dashboardIds.length ) {
						// There are more than one rows on this form.
						for( var i=0; i< theForm.dashboardIds.length; i++ ) {					
							theForm.dashboardIds[i].checked = selectAllControl.checked;
						}
					}
					// There is just a single row on this form.
					theForm.dashboardIds.checked = selectAllControl.checked;
					dijit.byId("delete").set("disabled",!selectAllControl.checked);
					enableDisableComponents(!selectAllControl.checked);			
				}

				// Function will return true if at least one check box is selected in Grid
				function checkAtLeastOneSelected() {				
					var frm = document.getElementById("dashboardListForm");
					if (frm.dashboardIds.length) { // if the checkbox group is an array (one check box is not an array)
						var noOfRows = frm.dashboardIds.length;
						for (i = 0; i < noOfRows; i++) {
							if (frm.dashboardIds[i].checked == true) {			
								return true;
							}
						}
					}else { // There is only one check box (it's not an array)
						if (frm.dashboardIds.checked) { // if the one check box is checked
							return true;
						}
					}
					return false;
				}
				
				function enableDisableButton_OnGridLoad(){							
					dijit.byId("delete").set("disabled",true);					
					enableDisableComponents(true);
				}

				function enableDisableComponents(value){					
					dijit.byId("topReport").set("disabled",value);
					dijit.byId("category").set("disabled",value);
					dijit.byId("privateReport").set("disabled",value);									
				}



				// Show OR Hide create top report options.
				function showTopReortDiv(responseData){					
					var topReortDiv = document.getElementById("topReortDiv");										
					if(responseData.dashboardListForm.canCreateTopReports == true){				
						topReortDiv.style.display="block";
					}else{				
						topReortDiv.style.display="none";
					}				
					
					if(responseData.createDashboardPermission == true){	
						dojo.byId("createBtnPanel").style.display="block";	
					}else{
						dojo.byId("createBtnPanel").style.display="none";				
					}
					document.getElementById("createPermission").value = responseData.createDashboardPermission;
					
					dijit.byId("topReport").set("disabled",true);				
					dijit.byId("category").set("disabled",true);				
					dijit.byId("privateReport").set("checked",false);				
					dijit.byId("privateReport").set("disabled",true);							
					dijit.byId("delete").set("disabled",true);
				}

				// Function will load paggination data. Set all Hidden variables
				function configurePaginationComponent(pageData){					
					dojo.byId("startRec").value=pageData.startRec;				
					dojo.byId("pageSize").value=pageData.pageSize;
					dojo.byId("userInput_pageSize").value=pageData.pageSize;
					dojo.byId("limitRec").value=pageData.limitRec;
					dojo.byId("totalRec").value=pageData.totalRec;
					dojo.byId("listSortOrder").value=pageData.listSortOrder;
					dojo.byId("listSortColumnName").value=pageData.listSortColumnName;
					dojo.byId("lastRecord").value=pageData.lastRecord;		
					var totalObjectCount = pageData.totalRec;							

					if(totalObjectCount!='undefined' && totalObjectCount > 0){								
						dojo.byId("pagination_div").style.display="block";		
						dojo.byId("pagination_text").innerHTML="";
						var firstImg = dojo.byId("first");
						var prevImg = dojo.byId("prev");
						if(pageData.startRec == 1 ){									
							firstImg.src = '/expensemap/jsp/images/beginning_disabled.gif';
							firstImg.title="<fmt:message key='tooltip.you.are.at.top'/>";
							firstImg.onclick=function(){};//donothing
								
							prevImg.src = '/expensemap/jsp/images/back_disabled.gif';			
							prevImg.title="<fmt:message key='tooltip.you.are.at.top'/>"
							prevImg.onclick = function(){};//donothing
						}else{

							firstImg.src = '/expensemap/jsp/images/beginning_enabled.gif';
							firstImg.title="<fmt:message key='tooltip.go.top'/>";
							firstImg.onclick=goToFirst;

							prevImg.src = '/expensemap/jsp/images/back_enabled.gif';
							prevImg.title=getToolTip("<fmt:message key='ui.image.tooltip.movePrevious'/>",pageData.pageSize);
							prevImg.onclick = goToPrev;
						}

						var nextImg = dojo.byId("next");
						var lastImg = dojo.byId("last");		
						if(pageData.limitRec == pageData.totalRec){
							
							nextImg.src = '/expensemap/jsp/images/forward_disabled.gif';
							nextImg.title="<fmt:message key='tooltip.you.are.at.bottom' />";
							nextImg.onclick= function(){};//donothing
								
							lastImg.src = '/expensemap/jsp/images/end_disabled.gif';
							lastImg.title="<fmt:message key='tooltip.you.are.at.bottom' />";	
							lastImg.onclick = function(){};//donothing
						}else{			
							nextImg.src = '/expensemap/jsp/images/forward_enabled.gif';
							var argForToolTip = ((pageData.totalRec-pageData.limitRec)>=pageData.pageSize)? pageData.pageSize : (pageData.totalRec - pageData.limitRec);
							nextImg.title=getToolTip("<fmt:message key='ui.image.tooltip.moveNext' />", argForToolTip);
							nextImg.onclick = goToNext;
							
							lastImg.src = '/expensemap/jsp/images/end_enabled.gif';
							lastImg.title="<fmt:message key='tooltip.go.bottom' />";
							lastImg.onclick = goToLast;
						}	
						dojo.byId("pagination_text").innerHTML = getPaginationText("<fmt:message key='ui.label.pagination.text' />",pageData.startRec,pageData.limitRec,pageData.totalRec);
					}else{
						dojo.byId("pagination_div").style.display="none";
					}
				}

				function getToolTip(msg,arg){			
					msg = msg.replace("{0}",arg);					
					return msg;
				}
					
				function getPaginationText(msg,startRec, limitRec, totalRec){
					msg = msg.replace("{0}", startRec);			
					msg = msg.replace("{1}" , limitRec);			
					msg = msg.replace("{2}", totalRec);			
					return msg;
				}
					
				function goToFirst(){getMaxRows('getFirst', false);}
				function goToPrev(){getMaxRows('getPrev', false);}
				function goToNext(){getMaxRows('getNext', false);}
				function goToLast(){getMaxRows('getLast', false);}

				function getMaxRows(action,applied){			
					var prevPageSize =dojo.byId("pageSize").value;
					var currPageSize = dojo.byId("userInput_pageSize").value;	
					if(!applied && prevPageSize!=currPageSize){				
						alert("<fmt:message key='ui.analytics.Navigate' />");
						return false;
					}else{				
						dojo.byId("pageSize").value = currPageSize;
						dojo.byId("theAction").value = action;				
						showAllDashboard();
					}											
				}

				function openHelp(){
					open( "<%=helpURL%>", "SA_Help" );	
				}
			</script>
	</head>

	<body class="claro">
		<% CubeUtil.buildExpMapMastHead(out,"viewFrame_analytic.jsp",zs,true,null,locale,null); %>
		<jsp:include page="/jsp/topMenu.jsp">
			<jsp:param name="topMenuForm" value="dashboardListForm"/>
			<jsp:param name="isDashboardListPage" value="true"/>
		</jsp:include> 
		
		<div id="containerDiv" class="container" >
			<form:form action="/expensemap/showDashboardPage.xhtm" commandName="dashboardListForm" id="dashboardListForm">
				<!-- Search Tabulation START --> 
				<table class="tableWithBorder">
					<tr>
						<td style="white-space:nowrap;"><b><fmt:message key="ui.label.Dashboards" /></b></td>
						<td align="center" style="width:100%"><b><fmt:message key="ui.usability.report.heading.datasetname"/>:&nbsp;<%=cubeName.toUpperCase()%></b></td>
						<td align="right" style="width:30px;">
							<a href="#" onclick="openHelp();">
								<img  src="/expensemap/jsp/cap_area/btn_help_up.gif" border="1" title="<fmt:message  key='ui.label.Help'/>"/>
							</a>						
						</td>
					</tr>
				</table>

				<div id="errorMsg_search" class="errorMsg"></div>

				<div id="searchDiv" class="searchContainer" data-dojo-type="dijit/TitlePane" data-dojo-props="title: '<fmt:message key='ui.label.search' />',open:false,duration:1000" >
					<table width="" border="0" cellspacing="0" cellpadding="0" >
						<tr><td>
							<div class="searchComponentContainer">
								<div class="searchComponent">
									<fmt:message key="ui.dashboard.name"/> &nbsp;&nbsp;
									<input type="text" name="search.dashboardName" id="search_dashboardName" data-dojo-type="dijit/form/TextBox" data-dojo-props="trim:true"/>
								</div>							
								<div class="searchComponent">
									<fmt:message key="rpt.listing.search.fromDate"/>&nbsp;&nbsp;
									<input type="text" name="search.fromDateStr" id="search_FromDate" data-dojo-type="dijit/form/DateTextBox" constraints="{datePattern:'${userDatePattern}'}"/>
								</div>
								<div class="searchComponent">
									<fmt:message key="rpt.listing.search.toDate"/>&nbsp;&nbsp;
									<input type="text" name="search.toDateStr" id="search_ToDate" data-dojo-type="dijit/form/DateTextBox" constraints="{datePattern:'${userDatePattern}'}"/>							
								</div>
								<div class="searchComponent">
									<fmt:message key="ui.label.Created.By"/> &nbsp;&nbsp;
									<input type="text" name="search.createdBy" id="search_createdBy" data-dojo-type="dijit/form/TextBox" data-dojo-props="trim:true"/>
								</div>								
							</div>
						</td></tr>
						<tr><td align="left" width="20%">				
							<div>
								<button data-dojo-type="dijit/form/Button" id="search" name="search" type="button" onClick="onSearch();">
									<fmt:message key="ui.label.search"/>
								</button>
								<button data-dojo-type="dijit/form/Button" id="resetSearch" name="resetSearch" type="button" onClick="onReset();">
									<fmt:message key="button.reset"/>									
								</button>
							</div>	  
						</td></tr>
					</table>				
				</div>
				<!-- END OF SEARCH TITLE PANE-->
				
				<!-- GRID ELEMENTS -->
				<div id="errorMsg_grid" class="errorMsg"></div>
				<br>
				<div id="Grid_Div" name="Grid_Div" class="objectGridDiv"></div>
				<!-- GRID ELEMENTS -->
				
				<div id="actionContainerDiv" class="actionContainerDiv">
					<div class="actionButton">					
						<div class="actionButton" id="createBtnPanel"> 
							<button data-dojo-type="dijit/form/Button" id="create" name="create" onClick="onCreate();"><fmt:message key="ui.button.Create"/></button>
						</div>
						<button data-dojo-type="dijit/form/Button" id="showAll" name="showAll" onClick="onShowAll();"><fmt:message key="show.all"/></button>					
						<button data-dojo-type="dijit/form/Button" id="delete" name="delete" onClick="onDelete();"><fmt:message key="ui.label.Delete" /></button>
					</div>
					<div id="topReortDiv" style="display:block;float:left;">
						<button data-dojo-type="dijit/form/Button" id="topReport" name="topReport" type="button" onClick="onTopReport();"><fmt:message key="button.SaveAsTopreports"/></button>					
						<div id="category_div"></div> &nbsp;
						<input type="checkbox" data-dojo-type="dijit/form/CheckBox" name="privateReport" id="privateReport" /> 
						<span><fmt:message key="ui.label.private.report"/></span>
					</div>
					<div id='pagination_div' class="paginationDiv">
						<img id="first" style="vertical-align:middle;"/> 
						<img id="prev" style="vertical-align:middle;"/> 
						<img id="next" style="vertical-align:middle;"/> 
						<img id="last" style="vertical-align:middle;"/> &nbsp;
						<label id="pagination_text"></label> &nbsp;
						<!--Msg need to externalized-->
						<input type="text" id="userInput_pageSize" required="true"
									   maxLength="3"									   
									   data-dojo-type="dijit/form/ValidationTextBox"
									   data-dojo-props="regExp:'\\d{0,3}',
														style:{width:'5em'},
														promptMessage: '<fmt:message key= 'ui.bookmark.grid.pagesize.promptmessage'/>',
														invalidMessage:'<fmt:message key= 'ui.alertmsg.rowsPerPage'/>',
														missingMessage:'<fmt:message key= 'ui.alertmsg.rowsPerPage'/>'														
														" />
									
						<button data-dojo-type="dijit/form/Button" id="applyPageSize" name="applyPageSize" type="button" onClick="onApplyPageSize();"><fmt:message key="button.apply"/></button>
					</div>
				</div> <!--End of actionContainerDiv -->
				<form:hidden id="startRec" path="pagination.startRec" />
				<form:hidden id="pageSize" path="pagination.pageSize" />
				<form:hidden id="limitRec" path="pagination.limitRec" />
				<form:hidden id="totalRec" path="pagination.totalRec" />
				<form:hidden id="lastRecord" path="pagination.lastRecord" />
				<form:hidden id="listSortOrder" path="pagination.listSortOrder" />
				<form:hidden id="listSortColumnName" path="pagination.listSortColumnName" />
				<form:hidden id="theAction" path="theAction"/>
				<input type ="hidden" id="createPermission" />
				<input type ='hidden' name="AuthCode" id="AuthCode" value="<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>"/>
			</form:form>
		</div>
	</body>	
</html>