<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ page pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>

<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@ page import="com.zeborg.expensemap.view.*, com.emptoris.viewer.util.CSRFHelper,java.net.URLEncoder" %>
<!DOCTYPE html>
<html>
<head>
<title><%=ExpenseMapAppProperties.getBrowserTitleSpend()%> - <fmt:message
	key="ui.label.expensemap.title.customize" /></title>
<jsp:include page="/jsp/includes/commonHeaderIncludes.jsp" />
<meta http-equiv="content-type" content="text/html; charset=utf-8" />

<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/connection/connection-min.js"></script>

<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/animation/animation-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/dragdrop/dragdrop-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/element/element-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/button/button-min.js"></script>
<script type="text/javascript" src="scripts/ddnode2.js"></script>

<style type="text/css">
body {
	font-family: Arial, Helvetica, sans-serif;
}

.toprow {
	background-color: #000066;
	font-size: 12px;
	font-weight: bold;
	color: #FFFFFF;
	padding: 6px;
}

.helprow {
	font-size: 11px;
	font-weight: normal;
	color: #000066;
	padding: 4px;
}

.helpicon {
	display: inline-block;
	padding-right: 8px;
	padding-bottom: 15px;
	padding-left: 5px;
	padding-top: 3px;
}

.subrow {
	background-color: #DBDBDB;
	font-size: 12px;
	font-weight: bold;
	color: #000066;
	padding: 6px;
}

.maintable {
	border: 1px solid #CCCCCC;
}

div.workarea {
	padding-right: 1px;
	padding-left: 1px;
	float: left;
	width: 100%;
	padding-bottom: 1px;
	padding-top: 1px;
	overflow: auto;
}

ul.draglist {
	border-right: none;
	padding-right: 0px;
	border-top: none;
	padding-left: 0px;
	background: #f7f7f7;
	padding-bottom: 0px;
	margin: 0px;
	border-left: none;
	width: 100%;
	padding-top: 0px;
	border-bottom: none;
	list-style-type: none;
	position: relative;
	height: ${maxDimsToDisplay*25}px;
}

.draglist li {
	height: 22px;
}

.dragItem {
	cursor: move;
	border: 1px;
	font-size: 12px;
	color: #000033;
	background: #AFADDE;
}

.note {
	font-size: 8pt;
	font-style: italic;
	color: red;
	padding: 1%;
}
</style>

</head>

<body>
<jsp:include page="/jsp/includes/simplePageHeader.jsp" />
<div class="note">
	<img src="/expensemap/jsp/images/happy_help_icon.gif" align="bottom" width="12" height="12" border="0" /> 
	<fmt:message key="ui.message.the.admin.has.restricted.the.number.of.visible.dimensions"><fmt:param value="${maxDimsToDisplay}" /></fmt:message>
</div>

<table width="695" border="1" align="center" cellpadding="1" cellspacing="0" bordercolor="#CCCCCC">
<tr>
	<td>
		<table width="695" border="0" align="center" cellpadding="0" cellspacing="0" class="maintable">
		<tr>
			<td class="toprow"><fmt:message key="ui.label.customizemyview" /></td>
		</tr>
		<tr>
			<td class="helprow">
				<img src="/expensemap/jsp/images/happy_help_icon.gif" width="11" height="13" align="left" class="helpicon" />
				<fmt:message key="ui.message.info.customizepage" />
			</td>
		</tr>
		<tr>
			<td>
				<table width="695" border="0" cellspacing="1" cellpadding="3">
				<tr>
					<td width="35%" class="subrow">
						<img src="/expensemap/jsp/images/verticalView.gif" width="29"
							height="16" hspace="5" align="absmiddle" /><fmt:message key="ui.label.leftview" /></td>
						<td width="1" rowspan="2" bgcolor="#CCCCCC"><img
							src="/expensemap/jsp/images/transparent.gif" width="1" height="1"
							title="" /></td>
						<td width="65%" class="subrow">
						<p><img src="/expensemap/jsp/images/mainView.gif" width="28"
							height="17" hspace="5" align="absmiddle" /><fmt:message key="ui.label.mainview" /></p>
						</td>
					</tr>
					<tr>
						<td width="35%" height="50%">
						<div class="workarea">
							<ul class="draglist" id="leftView">
							<c:forEach items="${leftViewDimensions}" var="dim">
								<li id="${dim.dimensionMeta.name}" class="dragItem" style="background-image: url('/expensemap/jsp/images/dimension-backgrounds/${dim.color.imageName}');" >
								<c:set var="lView">${dim.dimensionMeta.id.toString()}</c:set>
								<div style="padding-top: 4px;"><c:out value="${txtprops[lView]}"/></div></li>
							</c:forEach>
							</ul>
						</div>
						</td>
						<td width="65%" valign="top">
						<div class="workarea">
							<ul class="draglist" id="mainView">
								<li id="${mainViewDimension.dimensionMeta.name}" class="dragItem" style="background-image: url('/expensemap/jsp/images/dimension-backgrounds/${mainViewDimension.color.imageName}');" >
								<c:set var="mView">${mainViewDimension.dimensionMeta.id.toString()}</c:set>
								<div style="padding-top: 4px;"><c:out value="${txtprops[mView]}"/></div></li>
							</ul>
						</div>
						</td>
					</tr>
				</table>
				</td>
			</tr>
			<tr>
				<td class="subrow"><fmt:message key="ui.label.available.dimensions" /></td>
			</tr>
			<tr>
				<td>
				<table width="100%" border="0" cellspacing="0" cellpadding="3">
					<tr>
						<td>
						<div class="workarea" style="height: 205px;">
						<ul class="draglist" id="availableList">
							<c:forEach items="${availableDimensions}" var="dim">
								<li id="${dim.dimensionMeta.name}" class="dragItem" style="background-image: url('/expensemap/jsp/images/dimension-backgrounds/${dim.color.imageName}');" >
								<c:set var="aView">${dim.dimensionMeta.id.toString()}</c:set>
								<div style="padding-top: 4px;"><c:out value="${txtprops[aView]}"/></div></li>
							</c:forEach>
						</ul>							
						</div>
						</td>
					</tr>
				</table>
				</td>
			</tr>
		</table>
		</td>
	</tr>
</table>

<!-- New Mockup End -->

<table align="center">
	<tr align="center">
		<td colspan="2" align="center" height="30px">
		<input class="softbutton" type="button" id="saveBtn">&nbsp;
		<input class="softbutton" type="button" value="<fmt:message key='button.reset' />"	onclick="window.location.reload()">&nbsp;
		<input class="softbutton" type="button" value="<fmt:message key='button.close' />" onclick="window.close()"></td>
	</tr>
</table>
<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
<script type="text/javascript">
YAHOO.namespace('emptoris.viewer.preferences.UI');
(function() {
	var Event = YAHOO.util.Event;
	var Dom = YAHOO.util.Dom;
		
	YAHOO.emptoris.viewer.preferences.UI = {
    	init: function() {
            new YAHOO.util.DDTarget("leftView", null, {maxlen : ${maxDimsToDisplay - 1}});
            new YAHOO.util.DDTarget("mainView", null, {maxlen : 1});
            new YAHOO.util.DDTarget("availableList", null, {maxlen : -1});

            <c:forEach items="${leftViewDimensions}" var="dim">new YAHOO.emptoris.viewer.dd.DDNode("${dim.dimensionMeta.name}");</c:forEach>
            new YAHOO.emptoris.viewer.dd.DDNode("${mainViewDimension.dimensionMeta.name}");
            <c:forEach items="${availableDimensions}" var="dim">new YAHOO.emptoris.viewer.dd.DDNode("${dim.dimensionMeta.name}");</c:forEach>
            
            var onSave = function(e) {
        		var mainViewItems = Dom.getElementsByClassName("dragItem", "li", "mainView");
        		if (mainViewItems.length == 0) {
        			alert ("<fmt:message key='ui.message.select.one.dimension.in.main.panel' />");
        			return false;
        		}
        		var array = new Array();
        		array.push(mainViewItems[0].getAttribute("id")+':1');

        		var items = Dom.getElementsByClassName("dragItem", "li", "leftView");
        		for (var i = 0, n = items.length; i < n; i++) {
        			var item = items[i];
        			array.push(item.getAttribute("id")+':1');
        		}
        		<c:if test="${! empty requiredDims }">
        		var requiredDimensions = new Array();
        		var requiredDimensionsDispName = new Array();
        		<c:forEach items="${requiredDims}" var="dim">
        		requiredDimensions.push('${dim.name}');
        		requiredDimensionsDispName.push('<c:out value="${dim.displayName }" />');
        		</c:forEach>
        		for (var i = 0, n = requiredDimensions.length; i < n; i++) {
					if (jQuery.inArray(requiredDimensions[i] + ':1', array ) < 0 ) {
        				alert(requiredDimensionsDispName[i] + ' ' + "<fmt:message key='ui.message.crosstab.dimensions.can.not.be.moved' />");
        				return false;
        			}
        		}
        		</c:if>
        		
        		var availableItems = Dom.getElementsByClassName("dragItem", "li", "availableList");

        		for (var i = 0, n = availableItems.length; i < n; i++) {
        			var availableItem = availableItems[i];
        			array.push(availableItem.getAttribute("id")+':0');
        		}		
        		
        		var callback = {   
					 	success: function(o) {
					 		if ( o.responseText !== undefined) {
					 			window.opener.sendRequest('GetRootNodesRequest');
								window.close();
					 		} else {
								alert("Error " + o.responseText);
							}
					 	}
					};
        		var args = 'request=' + array.join("|");
        		<c:if test="${! empty param.bkId }">
        		args = args + "&bkId=${param.bkId}";
        		</c:if>        		
        		args = args +'&AuthCode=<%=URLEncoder.encode(CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION), "UTF-8")%>';
				YAHOO.util.Connect.asyncRequest('POST', "manageDimensionDisplayOrder.shtm", callback, args);
            };
            new YAHOO.widget.Button("saveBtn", {type: "submit", label: "<fmt:message key='ui.label.Save' />" });
            Event.on("saveBtn", "click", onSave );
    	}
	    	
		
	};
	
	Event.onDOMReady(YAHOO.emptoris.viewer.preferences.UI.init, YAHOO.emptoris.viewer.preferences.UI, true);
		
})(); 
      
</script>
</body>
</html>